const MaxFarben =  20;                          { bis 20 verschiedene Farben }
      MaxFolgen =  10;                          { nur 10 Folgen werden max. ausgegeben }
      MaxLaenge =  20;                          { Folgen sind nur 20 Wimpel max. lang }
                                                { (in den Beispielen sogar nur 18) }
type tWimpel = array[1..MaxFarben] of word;     { speichert Anzahl Wimpel pro Farbe }
     tNamen  = array[0..MaxFarben] of string;   { speichert Farbnamen }
     tFolge  = array[0..MaxLaenge] of word;     { speichert eine einzige Folge }

var AnzahlWimpel  : word;                       { Summe aller Wimpel }
    AnzahlFarben  : word;                       { Anzahl verschiedener Wimpel }
    Namen         : tNamen;                     { Namen der Farben }
    Folgen        : array[1..MaxFolgen] of tFolge; { die auszugebenen Folgen, max. 10 }
    AnzahlFolgen  : LongInt;                    { Anzahl der gefundenen Folgen }
    Wimpel        : tWimpel;                    { zur Verfgung stehende Wimpel }
    AktuelleFolge : tFolge;                     { derzeit bearbeitete Folge }


procedure SucheFolgen(Stelle: word);            { sucht nchsten passenden Wimpel,
                                                  wird rekursiv aufgerufen }
var DurchlaufWimpel : word;                     { Laufvariable }
    LinkerWimpel    : word;                     { linker Wimpel, mu ungleich dem jetzigen sein }
    AlleWimpelWeg   : boolean;                  { Folge zu Ende ? }
begin
   AlleWimpelWeg:=true;                         { annehmen, alle Wimpel seien weg }
   for DurchlaufWimpel:=1 to AnzahlFarben do    { alle Wimpel durchlaufen }
      if Wimpel[DurchlaufWimpel]>0 then         { doch noch welche da ? }
      begin
         AlleWimpelWeg:=false;                  { ja }
         break;                                 { zur Programmbeschleunigung Schleife abbrechen }
      end;

   if AlleWimpelWeg then                        { Folge ist zu Ende }
   begin
      inc(AnzahlFolgen);                        { Gesamtzahl der Folgen um 1 erhhen }
      if AnzahlFolgen<=10 then                  { weniger als 10 Folgen ? }
         Folgen[AnzahlFolgen]:=AktuelleFolge;   { ja, abspeichern }

      exit;                                     { Prozedur beenden }
   end;

   LinkerWimpel:=AktuelleFolge[Stelle-1];       { linken Wimpel holen }
   for DurchlaufWimpel:=1 to AnzahlFarben do    { alle Wimpel durchlaufen }
      if (Wimpel[DurchlaufWimpel]>0) and        { es mssen noch Wimpel da sein }
         (DurchlaufWimpel<>Linkerwimpel) then   { Farben mssen unterschiedlich sein }
      begin
         dec(Wimpel[DurchlaufWimpel]);          { 1 Wimpel ist jetzt weniger }
         AktuelleFolge[Stelle]:=DurchlaufWimpel;{ an Folge anhngen }

         SucheFolgen(Stelle+1);                 { nchsten Wimpel suchen }

         inc(Wimpel[DurchlaufWimpel])           { den nchsten Wimpel ausprobieren }
      end;
end;


var lauf1,lauf2 : word;                         { Laufvariablen }

begin
   write('Anzahl der Farben: ');                { Anzahl der Farben einlesen }
   readln(AnzahlFarben);

   for lauf1:=1 to AnzahlFarben do              { alle Farben durchlaufen }
   begin
      write('Farbe ',lauf1,': ');               { Namen einlesen }
      readln(Namen[lauf1]);
   end;

   AnzahlWimpel:=0;                             { Wimpel aufsummieren }
   for lauf1:=1 to AnzahlFarben do              { wieder alle Wimpel durchlaufen }
   begin
      write('Anzahl der ',Namen[lauf1],'en Wimpel: ');
      readln(Wimpel[lauf1]);                    { Anzahl der Wimpel pro Farbe einlesen }
      inc(AnzahlWimpel,Wimpel[lauf1]);          { auch Gesamtsumme erhhen }
   end;

   AnzahlFolgen:=0;                             { bisher keine Folge gefunden }
   AktuelleFolge[0]:=0;                         { linker Wimpel von Stelle 1 keine der benutzten Farben
                                                  => erster Wimpel kann beliebig sein }
   SucheFolgen(1);                              { Folge an Stelle 1 beginnen }

   writeln;                                     { Auswertung }
   case AnzahlFolgen of
        0: writeln('Geht nicht !!!');           { keine Folge gefunden }
    1..10: begin
              writeln('Reihenfolgen:');         { bis 10 Folgen }
              for lauf1:=1 to AnzahlFolgen do   { alle ausgeben }
              begin
                 for lauf2:=1 to AnzahlWimpel-1 do { einzelnen Namen ausgeben mit abschlieendem Komma }
                    write(Namen[Folgen[lauf1,lauf2]],',');
                 writeln(Namen[Folgen[lauf1,AnzahlWimpel]]); { auer dem letzten Namen }
              end;
           end;
      else begin                                { mehr als 10 Lsungen }
              writeln('Es gibt ',AnzahlFolgen,' Lsungen. Hier 3 davon:');
              for lauf1:=1 to 3 do              { nur 3 Folgen ausgeben }
              begin
                 for lauf2:=1 to AnzahlWimpel-1 do { einzelnen Namen ausgeben mit abschlieendem Komma }
                    write(Namen[Folgen[lauf1,lauf2]],',');
                 writeln(Namen[Folgen[lauf1,AnzahlWimpel]]); { auer dem letzten Namen }
              end;
           end;
   end;
end.